package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.ECDomainParameters;
import cn.com.infosec.crypto.params.ECKeyGenerationParameters;
import cn.com.infosec.crypto.params.ECPrivateKeyParameters;
import cn.com.infosec.crypto.params.ECPublicKeyParameters;
import cn.com.infosec.math.ec.ECConstants;
import cn.com.infosec.math.ec.ECPoint;
import java.math.BigInteger;
import java.security.SecureRandom;

public class ECKeyPairGenerator implements AsymmetricCipherKeyPairGenerator, ECConstants {
   ECDomainParameters params;
   SecureRandom random;

   public void init(KeyGenerationParameters param) {
      ECKeyPairGenerator var10000 = this;
      ECKeyGenerationParameters var2;
      this.random = (var2 = (ECKeyGenerationParameters)param).getRandom();
      var10000.params = var2.getDomainParameters();
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      BigInteger var1;
      int var2 = (var1 = this.params.getN()).bitLength();

      BigInteger var10000;
      BigInteger var3;
      do {
         do {
            var10000 = var3 = new BigInteger;
            var10000.<init>(var2, this.random);
         } while(var10000.equals(ECConstants.ZERO));
      } while(var3.compareTo(var1) >= 0);

      ECPoint var4 = this.params.getG().multiply(var3);
      return new AsymmetricCipherKeyPair(new ECPublicKeyParameters(var4, this.params), new ECPrivateKeyParameters(var3, this.params));
   }
}
